package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4j.object.JavaObject _exsettings = null;
public anywheresoftware.b4j.object.JavaObject _lp = null;
public anywheresoftware.b4j.object.JavaObject _lineprinter = null;
public anywheresoftware.b4j.object.JavaObject _lineprinterexception = null;
public anywheresoftware.b4j.object.JavaObject _printprogressevent = null;
public anywheresoftware.b4j.object.JavaObject _printprogresslistener = null;
public static String _sprinteruri = "";
public static String _sgrafico = "";
public static String _sfilejason = "";
public anywheresoftware.b4j.object.JavaObject _profiles = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _r = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"exSettings",mostCurrent._exsettings,"LinePrinter",mostCurrent._lineprinter,"LinePrinterException",mostCurrent._lineprinterexception,"lp",mostCurrent._lp,"PrintProgressEvent",mostCurrent._printprogressevent,"PrintProgressListener",mostCurrent._printprogresslistener,"Profiles",mostCurrent._profiles,"R",mostCurrent._r,"sFileJason",mostCurrent._sfilejason,"sGrafico",mostCurrent._sgrafico,"sPrinterURI",mostCurrent._sprinteruri};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 41;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(256);
 BA.debugLineNum = 45;BA.debugLine="InitializePrinter";
Debug.ShouldStop(4096);
_initializeprinter();
 BA.debugLineNum = 47;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 53;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 55;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
 BA.debugLineNum = 49;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(65536);
 BA.debugLineNum = 51;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static anywheresoftware.b4j.object.JavaObject  _getba() throws Exception{
try {
		Debug.PushSubsStack("GetBA (main) ","main",0,mostCurrent.activityBA,mostCurrent);
anywheresoftware.b4j.object.JavaObject _jo = null;
String _cls = "";
 BA.debugLineNum = 90;BA.debugLine="Sub GetBA As JavaObject";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 91;BA.debugLine="Dim jo As JavaObject";
Debug.ShouldStop(67108864);
_jo = new anywheresoftware.b4j.object.JavaObject();Debug.locals.put("jo", _jo);
 BA.debugLineNum = 92;BA.debugLine="Dim cls As    String = Me";
Debug.ShouldStop(134217728);
_cls = BA.ObjectToString(main.getObject());Debug.locals.put("cls", _cls);Debug.locals.put("cls", _cls);
 BA.debugLineNum = 93;BA.debugLine="cls = cls.SubString( \" class \" .Length)";
Debug.ShouldStop(268435456);
_cls = _cls.substring(" class ".length());Debug.locals.put("cls", _cls);
 BA.debugLineNum = 94;BA.debugLine="jo.InitializeStatic(cls)";
Debug.ShouldStop(536870912);
_jo.InitializeStatic(_cls);
 BA.debugLineNum = 95;BA.debugLine="Return jo.GetFieldJO( \" processBA \" )";
Debug.ShouldStop(1073741824);
if (true) return _jo.GetFieldJO(" processBA ");
 BA.debugLineNum = 96;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return null;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static anywheresoftware.b4j.object.JavaObject  _getcontext() throws Exception{
try {
		Debug.PushSubsStack("GetContext (main) ","main",0,mostCurrent.activityBA,mostCurrent);
 BA.debugLineNum = 86;BA.debugLine="Sub GetContext As JavaObject";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 87;BA.debugLine="Return GetBA.GetField( \" context \" )";
Debug.ShouldStop(4194304);
if (true) return (anywheresoftware.b4j.object.JavaObject) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), (java.lang.Object)(_getba().GetField(" context ")));
 BA.debugLineNum = 88;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return null;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 18376, new int[] {4}, "8721330a-176a-461e-ac4b-3fa48388ac9c");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Dim exSettings As JavaObject";
mostCurrent._exsettings = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 27;BA.debugLine="Dim lp As JavaObject";
mostCurrent._lp = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 28;BA.debugLine="Dim LinePrinter As JavaObject";
mostCurrent._lineprinter = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 29;BA.debugLine="Dim LinePrinterException As JavaObject";
mostCurrent._lineprinterexception = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 30;BA.debugLine="Dim PrintProgressEvent As JavaObject";
mostCurrent._printprogressevent = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 31;BA.debugLine="Dim PrintProgressListener As JavaObject";
mostCurrent._printprogresslistener = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 32;BA.debugLine="Dim sPrinterURI As String";
mostCurrent._sprinteruri = "";
 //BA.debugLineNum = 33;BA.debugLine="Dim sGrafico As String";
mostCurrent._sgrafico = "";
 //BA.debugLineNum = 34;BA.debugLine="Dim sFileJason As String";
mostCurrent._sfilejason = "";
 //BA.debugLineNum = 35;BA.debugLine="Dim Profiles As JavaObject";
mostCurrent._profiles = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 36;BA.debugLine="Dim R As Reflector";
mostCurrent._r = new anywheresoftware.b4a.agraham.reflection.Reflection();
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _initializeprinter() throws Exception{
try {
		Debug.PushSubsStack("InitializePrinter (main) ","main",0,mostCurrent.activityBA,mostCurrent);
 BA.debugLineNum = 57;BA.debugLine="Sub InitializePrinter";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 59;BA.debugLine="LinePrinter.InitializeStatic(\"com.intermec.print.lp.LinePrinter\")";
Debug.ShouldStop(67108864);
mostCurrent._lineprinter.InitializeStatic("com.intermec.print.lp.LinePrinter");
 BA.debugLineNum = 60;BA.debugLine="LinePrinterException.InitializeStatic(\"com.intermec.print.lp.LinePrinterException\")";
Debug.ShouldStop(134217728);
mostCurrent._lineprinterexception.InitializeStatic("com.intermec.print.lp.LinePrinterException");
 BA.debugLineNum = 61;BA.debugLine="PrintProgressEvent.InitializeStatic(\"com.intermec.print.lp.PrintProgressEvent\")";
Debug.ShouldStop(268435456);
mostCurrent._printprogressevent.InitializeStatic("com.intermec.print.lp.PrintProgressEvent");
 BA.debugLineNum = 62;BA.debugLine="PrintProgressListener.InitializeStatic(\"com.intermec.print.lp.PrintProgressListener\")";
Debug.ShouldStop(536870912);
mostCurrent._printprogresslistener.InitializeStatic("com.intermec.print.lp.PrintProgressListener");
 BA.debugLineNum = 63;BA.debugLine="exSettings.InitializeNewInstance(\"com.intermec.print.lp.LinePrinter.ExtraSettings\",Null)";
Debug.ShouldStop(1073741824);
mostCurrent._exsettings.InitializeNewInstance("com.intermec.print.lp.LinePrinter.ExtraSettings",(Object[])(anywheresoftware.b4a.keywords.Common.Null));
 BA.debugLineNum = 67;BA.debugLine="exSettings.RunMethod(\"setContext\",Array(Activity))'',Array(R.GetActivity ))";
Debug.ShouldStop(4);
mostCurrent._exsettings.RunMethod("setContext",new Object[]{(Object)(mostCurrent._activity.getObject())});
 BA.debugLineNum = 70;BA.debugLine="sPrinterURI = \"bt://00:1D:DF:FE:A3:5F\"";
Debug.ShouldStop(32);
mostCurrent._sprinteruri = "bt://00:1D:DF:FE:A3:5F";
 BA.debugLineNum = 72;BA.debugLine="sFileJason=File.DirRootExternal & \"/printer_profiles.JSON\"";
Debug.ShouldStop(128);
mostCurrent._sfilejason = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal()+"/printer_profiles.JSON";
 BA.debugLineNum = 75;BA.debugLine="lp.InitializeNewInstance(\"com.intermec.print.lp.LinePrinter\",Array(sFileJason,\"PR3-03021446522\",sPrinterURI,exSettings))";
Debug.ShouldStop(1024);
mostCurrent._lp.InitializeNewInstance("com.intermec.print.lp.LinePrinter",new Object[]{(Object)(mostCurrent._sfilejason),(Object)("PR3-03021446522"),(Object)(mostCurrent._sprinteruri),(Object)(mostCurrent._exsettings.getObject())});
 BA.debugLineNum = 77;BA.debugLine="sGrafico=File.DirRootExternal &  \"/Signature.bmp\"";
Debug.ShouldStop(4096);
mostCurrent._sgrafico = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal()+"/Signature.bmp";
 BA.debugLineNum = 79;BA.debugLine="lp.RunMethod(\"connect\",Null)";
Debug.ShouldStop(16384);
mostCurrent._lp.RunMethod("connect",(Object[])(anywheresoftware.b4a.keywords.Common.Null));
 BA.debugLineNum = 80;BA.debugLine="lp.RunMethod(\"writeGraphic\",Array(sGrafico,0,0,400,200))";
Debug.ShouldStop(32768);
mostCurrent._lp.RunMethod("writeGraphic",new Object[]{(Object)(mostCurrent._sgrafico),(Object)(0),(Object)(0),(Object)(400),(Object)(200)});
 BA.debugLineNum = 81;BA.debugLine="lp.RunMethod(\"disconnect\",Null)";
Debug.ShouldStop(65536);
mostCurrent._lp.RunMethod("disconnect",(Object[])(anywheresoftware.b4a.keywords.Common.Null));
 BA.debugLineNum = 82;BA.debugLine="lp.RunMethod(\"close\",Null)";
Debug.ShouldStop(131072);
mostCurrent._lp.RunMethod("close",(Object[])(anywheresoftware.b4a.keywords.Common.Null));
 BA.debugLineNum = 84;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
}
